.\" @(#)fv  2.20  98/01/19  cdh
.\" Copyright (c) 1991 - 1998  Chris Hooper (cdh@mtu.edu)
.\" All rights reserved.
.\"
.TH FV l "19-Jan-98" "MTU - cdh"
.SH NAME
fv \- binary file viewer/editor
.SH SYNOPSIS
.B fv
[
.B \-hrsvw
] [
.B -k
.I STRING
]
.I filename
.I  ...
.SH DESCRIPTION
.LP
.B fv
is a \*(lqfriendly\*(rq editor for binary files.  Its function
is similar to that of vi for text files, and has a familiar
feel for those who are comfortable with vi.
.br
.sp 1
Simple online help is available by typing Control-H
in most fv modes.  Scrolling up and down
in the window is very similar to motion in
.I more
or
.I vi.
In some environments, the cursor keypad may also be used to 
more around in the file.  Most edit commands will operate
multiple times when preceded by a number.
.SH OPTIONS
.TP
.B \-a
Edit memory at specified address (range)
.br
 Address is "START" or "START-END" or "START:END"
.TP
.B \-h
Display command parameter syntax.
.TP
.B \-k
Specify the initial keystrokes to perform
.TP
.B \-r
Specify this file as read only (do not modify).
.TP
.B \-s
Perform editing with no screen display
.TP
.B \-v
Print the current fv version number and exit.
.TP
.B \-w
Try to force write mode even if the file is read-only.
.br
.sp 1
.SH EDITOR KEYS
.B Main Editor State:
.br
	 0-9     	Enter number of times to perform command
.br
	 a     	Address display on/off
.br
	 A     	Append to file from cursor until mark
.br
	 b    	Back one full display page
.br
	^B    	Back one full display page
.br
	 c     	Character display on/off
.br
	 C     	Copy to file from cursor position to mark
.br
	^C     	Exit (do not ask to save)
.br
	 d    	Down one half display page
.br
	^D    	Down one half display page
.br
	 f    	Forward one full display page
.br
	 F    	Select new file from list on command line
.br
	^F    	Forward one full display page
.br
	 g     	Go to specific byte position (hex) in file
.br
	 G     	Go to bottom of file
.br
	^G     	Show current filename and cursor position
.br
	 h     	Cursor left
.br
	 H     	Buffer window left
.br
	^H     	Help screen
.br
	^I     	{tab} Change word search mode (string/hex)
.br
	 j     	Cursor down
.br
	 J     	Buffer window down
.br
	^J     	[Return] Start editing either String or Hex
.br
	 k     	Cursor up
.br
	 K     	Buffer window up
.br
	 l     	Cursor right
.br
	 L     	Buffer window right
.br
	^L     	Redraw screen
.br
	 m     	Set mark (type mark character)
.br
	 M     	Move cursor to middle of screen
.br
	^M     	[Return] Start editing either String or Hex
.br
	 n     	Search again in current direction
.br
	 N     	Search again, but in opposite direction
.br
	 o      	Change display char for non-ASCII and zero
.br
	 O      	Change display char for non-ASCII and zero
.br
	 q      	Exit (ask to save if modified)
.br
	 Q      	Exit (ask to save if modified)
.br
	 r     	Reread page
.br
	 R     	Change Read-only mode
.br
	 s     	Change byte swapping mode (off, word, long)
.bre
	 S      	Toggle byte swapping relative to chars/words
.br
	 t     	Toggle word display type (hex/dec)
.br
	 T     	Cycle word display type (hex/dec/float/dbl)
.br
	 u    	Up one half display page
.br
	^U    	Up one half display page
.br
	 w     	Toggle Word display on/off
.br
	 W      	Write current buffer contents to file
.br
	^W   	Write current buffer contents to file
.br
	 x     	Exit (ask to save if modified)
.br
	^X     	Exit (ask to save if modified)
.br
	 z     	Set current line at top "z<CR>", middle "z.",
.br
	       	bottom "z-", or force bottom to top "z+"
.br
	 0     	Beginning of file/top of screen
.br
	 /     	Search forward for String/Hex
.br
	 ?     	Search backward for String/Hex
.br
	 ^     	Go to beginning of current display row
.br
	 $     	Go to end of current display row
.br
	 +     	Add more display columns (up to screen size)
.br
	 =     	Add more display columns (up to screen size)
.br
	 -     	Subtract display columns (down to one column)
.br
	 _     	Subtract display columns (down to one column)
.br
	 '    	Go to mark (mark character or ' for last)
.br
	 `    	Go to mark (mark character or ' for last)
.br
	 (     	Go to top/left of screen
.br
	 )     	Go to bottom/right of screen
.br
	 <     	Increase cursor alignment (1, 2, 4, 8 bytes)
.br
	 >     	Decrease cursor alignment (1, 2, 4, 8 bytes)
.br
	 [     	Double lower status address display div/mod
.br
	 ]     	Halve lower status address display div/mod
.br
	 {     	Double left address address display div/mod
.br
	 }     	Halve left address address display div/mod
.br
	 "     	Toggle status range address between div/mod
.br
	 ~     	Toggle left address address between div/mod
.br
	 .     	Go to string editor and repeat last session
.br
	 :     	Enter colon mode command
.br

.br
.B Editor State, Hex Edit Mode
.br
		 0-9	Change the current hex digit
.br
		 a-f	Change the current hex digit
.br
		^H	Cursor left
.br
		 h	Cursor left
.br
		 j	Cursor down
.br
		 k	Cursor up
.br
		 l  	Cursor right
.br
		 q	Quit editing the string, do not store
.br
		^M	Finished editing (same as return)
.br
		 q	Quit editing the string, do not store
.br
		^X	Quit editing the string, do not store
.br
		 ?  	Display online help information
.br

.br
.B Editor State, String Edit Mode
.br
.BI	ESC\ Mode:
.br
		 a   	Add after cursor, enter insert mode
.br
		 A   	Add at end of string, enter insert mode
.br
		 b   	Go to previous word
.br
		 c	f   	Delete including character, insert mode
.br
		 c	t   	Delete to character, put in insert mode
.br
		 c	w   	Delete word, put in insert mode
.br
		 c	^   	Delete to start of string, insert mode
.br
		 c	0   	Delete to start of string, insert mode
.br
		 c	$   	Delete to end of string, insert mode
.br
		 C   	Change to end of string
.br
		 d	f   	Delete including character
.br
		 d	t   	Delete to character
.br
		 d	w   	Delete word
.br
		 d	^   	Delete to start of string
.br
		 d	0   	Delete to start of string
.br
		 d	$   	Delete to end of string
.br
		 D   	Delete to end of string
.br
		 e   	Go to end of this word or next
.br
		 f   	Go to next character typed
.br
		 G   	Go to end of string
.br
		 h   	Cursor left
.br
		^H   	Cursor left
.br
		 i   	Insert at cursor, enter insert mode
.br
		 I   	Insert at start of string, insert mode
.br
		 j   	Cursor down
.br
		 k   	Cursor up
.br
		 l   	Cursor right
.br
		^M   	Finished editing (same as return)
.br
		 q   	Quit editing the string, do not store
.br
		 r   	Replace single character
.br
		 R   	Replace multiple characters (overstrike)
.br
		 s   	Substitute for single character
.br
		 t   	Go to character prior to next typed key
.br
		 T   	Go to character prior to next typed key
.br
		 u   	Undo last change
.br
		 U   	Undo all changes to string
.br
		 w   	Go to next word
.br
		 x   	Erase single character
.br
		^X   	Quit editing the string, do not store
.br
		 0   	Beginning of string
.br
		 $   	End of line
.br
		 ~   	Switch case of letter at cursor position
.br
		 .   	Repeat last edit command
.br
		 ^   	Beginning of string
.br
		 ?   	Display online help information
.br
		 ESC 	Enter ESC command mode
.br
.BI	Insert\ Mode\ only:
.br
		^H   	Delete left of cursor (backspace key)
.br
		^V   	Add next raw character to string
.br

.SH ENVIRONMENT
.LP
.br
The editor recognizes the environment variable FVINIT as a list
of key commands to execute on startup as if entered by the keyboard.
This is done before the display is brought active, so that preferred
fv mode commands can be placed into the FVINIT and executed
automatically at invocation.  In the event of having both this
environment variable set and specifying the -k parameter, the
commands specified in the FVINIT environment variable will always
be executed first.
.br
.SH EXAMPLES
.LP
.br
The following command:
.SS	%  fv -s -k '/_exit\\\\015n\\\\015cw_die\\\\015qy' deathbin
.SS
will search out the keyword _exit in file deathbin and
change it to be _die.
.br
.SH SEE ALSO
.BR vi (1),
.BR od (1V).
.SH NOTES
.LP
.br
In the main editor and string editor, entering a number before
a command repeats that command similar to vi (but will work for
functions such as searching and editing as well).
.br

.SM fv
is mainly a stable product, but segmentation faults should be expected
at the least unexpected moments.
.br

.br
This program is freeware meaning that it may not be sold for profit
or included in a package which is sold for commercial gain.  The
author grants fitness of this product for NO purpose, nor is
liable for damages incurred as the result of attempting to apply this
product for a purpose, sane or otherwise.
.br

    fv is Copyright 1991-1998  Chris Hooper (cdh@mtu.edu)
